=begin
(c) TIG & Rich 2011
All Rights Reserved.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED 
WARRANTIES,INCLUDING,WITHOUT LIMITATION,THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

Script: AnchorPoints.rb

Adds Plugins Menu Item 'Anchor Points' which places
a construction at a Group/Component Bounding Box corners.
Construction Points are placed on a layer named 'Anchor Points'

Donations: By PayPal.com to info @ revitrev.org

v1.0 First release. 10/11/2011

=end  
  
  module ROB
	require 'sketchup.rb'
    menu=UI.menu("Plugins").add_item("Anchor Points"){self.bbcpts()}unless file_loaded?(File.basename(__FILE__))
    file_loaded(File.basename(__FILE__))

    def self.bbcpts()
        m=Sketchup.active_model;m.start_operation("BBcpts");
		m.selection.each{|e|next unless e.class==Sketchup::Group or e.class==Sketchup::ComponentInstance;
		e=e.definition if e.class==Sketchup::ComponentInstance;
		b=Geom::BoundingBox.new;e.entities.each{|a|b.add(a.bounds)};
		8.times{|i|e.entities.add_cpoint(b.corner(i)).layer=m.layers.add("Anchor Points")}};
		m.commit_operation
    end

    end
